/*
 * j2eeadmin -addJmsDestination Favorite topic
 */
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;
import javax.jms.TopicSubscriber;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class ChatClient implements MessageListener
{

TopicConnection connection = null;
private TopicPublisher publisher = null;
private TopicSubscriber subscriber = null;
private TopicSession pubSession = null;
private TopicSession subSession = null;

	public ChatClient()
	{
	try
	{
	InitialContext jndi = new InitialContext();
	TopicConnectionFactory conFactory = (TopicConnectionFactory)jndi.lookup("TopicConnectionFactory");
	connection = conFactory.createTopicConnection();
	pubSession = connection.createTopicSession(false, Session.AUTO_ACKNOWLEDGE);
	subSession = connection.createTopicSession(false, Session.AUTO_ACKNOWLEDGE);

	Topic chatTopic = (Topic)jndi.lookup("Favorite");

	subscriber = subSession.createSubscriber(chatTopic);
	publisher = pubSession.createPublisher(chatTopic);

	subscriber.setMessageListener(this);

	connection.start();
	}
	catch(NamingException ex)
	{
		ex.printStackTrace();
	}
	catch(JMSException ex)
	{
		ex.printStackTrace();
	}
	}

	public static void main(String[] args)
	{
	ChatClient client = new 
	ChatClient();
	BufferedReader commandLine = new 
	BufferedReader(new InputStreamReader(System.in));
	System.out.println("Start Chart");
	while(true)
	{
	String msg = null;
	try
	{
	msg = commandLine.readLine();
	}
	catch(IOException ex)
	{
		ex.printStackTrace();
	break;
	}
	if(msg.equalsIgnoreCase("exit"))
	{
		break;
	}
	client.writeMessage(msg);
	}
	client.close();
	System.exit(0);
	}

	public void onMessage(Message message)
	{
	TextMessage textMessage = (TextMessage)message;
	try
	{
	System.out.println("RCV > " + textMessage.getText());
	}
	catch(JMSException ex)
	{
		ex.printStackTrace();
	}
	}

	public void writeMessage(String msg)
	{
	try
	{
	TextMessage message = pubSession.createTextMessage();
	message.setText(msg);
	publisher.publish(message);
	}
	catch(JMSException ex)
	{
		ex.printStackTrace();
	}
	}

	public void close()
	{
	try
	{
	connection.close();
	}
	catch(JMSException ex)
	{
		ex.printStackTrace();
	}
	}
}
