/*
p to p
Java HelloWorldJmsConsumer
*/

import javax.jms.*;
import javax.naming.*;

public class HelloWorldJmsConsumer {
  public final static String JMS_FACTORY="QueueConnectionFactory";
  public final static String QUEUE="MyQueue";

  public static void main(String[] args) {
    try {
      QueueConnectionFactory queueConnectionFactory;
      QueueConnection queueConnection;
      QueueSession queueSession;
      QueueReceiver queueReceiver;
      Queue queue;
      TextMessage msg;

      InitialContext ctx = new InitialContext();

      queueConnectionFactory  = (QueueConnectionFactory)ctx.lookup(JMS_FACTORY);
      queue = (Queue) ctx.lookup(QUEUE);

      queueConnection = queueConnectionFactory.createQueueConnection();
      queueSession = queueConnection.createQueueSession(false,Session.AUTO_ACKNOWLEDGE);
      queueReceiver = queueSession.createReceiver(queue);
      queueConnection.start();
      while (true) {
        Message m = queueReceiver.receive(1);
        if (m != null) {
          if (m instanceof TextMessage) {
            msg = (TextMessage) m;
            System.out.println(msg.getText());
          } else {
            break;
          }
        }
      }

      queueReceiver.close();
      queueSession.close();
      queueConnection.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}